var fs = require('fs'),
Step = require('step'),
ini = require('ini');

exports.plugin = function(router) {
	
	var scaffolders = { };
	
	fs.readdirSync(__dirname + '/default').forEach(function(module) {
		
		if(module.substr(0,1) == '.') return;
		
		scaffolders[module.replace(/.js$/,'')] = require(__dirname + '/default/' + module);
	})
	
	
	router.on({
		
		/**
		 */
		
		'pull command/execute/scaffold': function(request) {
			
			var args = request.data.args,
			cwd = args.length > 1 ? args.shift() : process.cwd(),
			ops = (args.shift() || '').split('+'),
			config = { commands: {} };
			
			try	{
				
				ini.parse(fs.readFileSync(cwd + '/.cupboard','utf8'));
			} catch(e) {
				
			}
			
			var steps = [],
			buildOps = request.data;
			
			ops.forEach(function(op) {
				
				var scaffolder = scaffolders[op];
				
				if(!scaffolder) {
					
					console.warn('Scaffolder "%s" does not exist'.red, op.bold);
					return;
				}
				
				steps.push(function(err, result) {
					
					buildOps.cwd = cwd;
					buildOps.config = config;
					
					scaffolder.build(buildOps, this)
				});
			});
			
			steps.push(function(err, result) {
				
				fs.writeFileSync(cwd + '/.cupboard', ini.stringify(config));
				//console.log("done");
				process.exit(0);
			})
			
			
			if(steps.length) Step.apply(null, steps);
		},
		
		/**
		 */
		
		'push init': function() {
			//router.pull('project/scaffolding')
		},
		
		/**
		 */
		
		
		
		/**
		 */
		
		'pull -multi help/item': function() {
			return {
				commands: [ {
					
					command: 'scaffold <type>',
					desc: 'Initializes target scaffold in cwd'
				} ],
				examples: [ {
					command: 'scaffold textmate+node',
					desc: '  '
				} ]
			};
		}
		
		
	})
}
